#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
#include <EEPROM.h>
#include <Wire.h>                                   // I2C -Bibliothek 
#include "Index.h"
#include "WEBset.h"
extern "C" {
#include "user_interface.h"
}

#define DNS
#define ESP01
IPAddress apIP(192, 168, 178, 1);
 
#if defined DNS
#include <DNSServer.h>
const byte DNS_PORT = 53;
DNSServer dnsServer;
#endif

String BenuzPass = "";
char ssid[32] = "fhgdhfghd\0";
char passwort[64] = "gghdfgh\0";
ESP8266WebServer server;
EspClass esp;
int z = 0;                   //Aktuelle EEPROM-Adresse zum lesen
#include "Setup.h"

int i = 0;
boolean AP=0;   // Acsespoint Modus aus

void setup()                // Wird 1 Mal beim Start ausgefuehrt
{
  char inser;               // Serielle daten ablegen
  String nachricht = "";    //  Setup Formular
#if defined ESP01
  Wire.begin(2, 0);
#else
  Wire.begin(5, 4);   // I2C-Bus initialisieren GPIO5-Data GPIO4-Clock
#endif
  Wire.setClock(1000);                              // I2C-Bus Freqenz
  Wire.requestFrom(32, 1);    // wegen mühlausgaben auf dem I2C
  while (Wire.available())   i = Wire.read(); // receive a byte as character

  EEPROM.begin(250);                                 // EEPROM initialisieren mit 200 Byts
  Serial.begin(115200);

  while (Serial.available())inser = Serial.read();  // Setup Weiche, Erkennen ob TXD/RXD gebrückt sind
  Serial.println("Start");
  delay(10);
  inser = Serial.read();
  if (inser != 'S') goto weiter;
  inser = Serial.read();
  if (inser != 't') goto weiter;
  Einstellen();

weiter:


  z = 0;
  LeseEeprom(ssid, sizeof(ssid));        // EEPROM lesen
  if (ssid[0] == 255) // Wenn EEPROM leer ist dann:
  {
    for (i = 0; i < 6; i++) EEPROM.write(i, '\0');
    EEPROM.commit();
    Einstellen();
  }
  LeseEeprom(passwort, sizeof(passwort));
  LeseEepromStr(&BenuzPass, 50);
  if (ssid[0] == 0)Einstellen();

  if (ssid[0] == '0')
  {
    Serial.println("Starte in Access Point modus" );
    Serial.println("SSID \"I2C-Server\" IP 192,168,178,1");
    WiFi.mode(WIFI_AP);      // access point modus
    WiFi.softAPConfig(apIP, apIP, IPAddress(255, 255, 255, 0));
    WiFi.softAP("I2C-Server", passwort);  // Name des Wi-Fi netzes
	#if defined DNS
    dnsServer.start(DNS_PORT, "*", apIP);
	#endif
    AP=1;
  }
  else
  {
    Serial.print("Verbinde mit ");
    Serial.println(ssid);
    WiFi.mode(WIFI_STA);
    WiFi.begin(ssid, passwort);


#if defined ESP01
#else
    pinMode(2, OUTPUT);
#endif


    while (WiFi.status() != WL_CONNECTED) {
#if defined ESP01
      delay(1000);
      Serial.print("O");
#else
      digitalWrite(2, 0);
      delay(100);
      digitalWrite(2, 1);
      delay(100);
#endif
    }

    Serial.begin(115200);
    Serial.println("");
    Serial.println("Mit Wlan verbunden");
    Serial.println("IP Adresse: ");
    Serial.println(WiFi.localIP());
    Serial.print("Benutzerpasswort : ");
    Serial.println(BenuzPass);
  }// Wenn nicht SSID 0
  //  Bechandlung der Ereignissen anschlissen
  server.on("/", Ereignis_Index);
  server.on("/I2C.php", Ereignis_Befehl);
  server.on("/Durchsuchen.php", Ereignis_Durchsuchen);
  server.on("/ADC.php", Ereignis_ADC);
  server.on("/SetI2C.php", Ereignis_Befehl2);
  server.on("/GetI2C.xml", Ereignis_GetXML);
  server.onNotFound ( handleNotFound );

  server.begin();  // Starte den Server
  Serial.print("HTTP Server gestartet");
}

void Ereignis_Befehl()      // Wird ausgefuehrt wenn "http://<ip address>/schalte.php" aufgerufen wurde
{
  String Antwort = "";

  String Adresse = server.arg("Adress");          // Relais Nr. empfangen
  int Adr = Adresse.toInt();                         // String zu Integer konvertieren

  String Anzahl = server.arg("Bytes");
  int Bytes = Anzahl.toInt();

  String Data = server.arg("Daten");
  int pos1 = 0, pos2;

  String pass2 = server.arg("Passwort");


  if (bitRead(Adr, 0))
  { // Lesen
    Adr = Adr >> 1;
    Wire.requestFrom(Adr, Bytes);    //
    while (Wire.available())
    {
      i = Wire.read(); // receive a byte as character
      Antwort += String(i);
      Antwort += ";";
    }
  }
  else
  { // Schreiben
    if (pass2 != BenuzPass)
    {
      Antwort = "Falsches Passwort";
      goto ueberspringe;
    }
    Adr = Adr >> 1;
    Wire.beginTransmission(Adr);
    while (1)
    {
      pos2 = Data.indexOf(';', pos1);
      if (Data.indexOf(';', pos1) == -1)break;
      String wert = Data.substring(pos1, pos2);
      pos1 = pos2 + 1;
      // Serial.println(wert);
      Wire.write(wert.toInt());
    }
    // Byte senden Daten werden Inveriert
    Wire.endTransmission();                           // I2C Stopbedingung
    Antwort = "OK";
  }
ueberspringe:
  server.sendHeader("Cache-Control", "no-cache");
  server.send(200, "text/plain", Antwort); // Antwort an Internet Browser senden
}

void Ereignis_Durchsuchen()
{
  String  s = "Liste erreichbaren Adressen\r\n\r\n";
  int i;
  char g;
  for (i = 1; i <= 127; i++)
  {
    Wire.requestFrom(i, 20);
    if (Wire.available())
    {
      s += "Adresse " + String(i * 2);
      while (Wire.available()) g = (Wire.read());
      s += "\r\n";
    }
  }
  server.send(200, "text / plain", s);
}
/*
 Code: Alles auswählen
extern "C" {
#include "user_interface.h"
}

uint LDR_Value = 0; //Value of LDR (ADC)

LDR_Value=system_adc_read();
extern "C" {
#include "user_interface.h"
}

uint LDR_Value = 0; //Value of LDR (ADC)

LDR_Value=system_adc_read();
 */

void Ereignis_ADC()
{
  uint ADCValue = 0;
  ADCValue = system_adc_read();
  String Antwort = "";
  Antwort = String(ADCValue, DEC);
  /*
  i = analogRead(A0);
  Antwort = String(i, DEC);
  */

  server.sendHeader("Cache-Control", "no-cache");
  server.send(200, "text/plain", Antwort); // Antwort an Internet Browser senden

}

void Ereignis_Befehl2()
{
  String Antwort = "";
  String pass2 = server.arg("Passwort");
  for ( uint8_t br = 0; br < server.args(); br++ )
  {
    String Adresse = server.argName ( br );          // Relais Nr. empfangen
    int Adr = Adresse.toInt();
    if (Adr)
    {

      String Data = server.arg (br);
      int pos1 = 0, pos2;
      if (bitRead(Adr, 0))
      { // Lesen
        int Bytes = Data.toInt();
        Adr = Adr >> 1;
        Wire.requestFrom(Adr, Bytes);    //
        while (Wire.available())
        {
          i = Wire.read(); // receive a byte as character
          Antwort += String(i);
          Antwort += ";";
        }
      } //if lesen
      else
      { // Schreiben
        if (pass2 != BenuzPass)
        {
          Antwort = "Falsches Passwort";
          goto ueberspringe;
        }
        Adr = Adr >> 1;
        Wire.beginTransmission(Adr);
        while (1)
        { // mehrere daten
          pos2 = Data.indexOf(';', pos1);
          if (Data.indexOf(';', pos1) == -1)break;
          String wert = Data.substring(pos1, pos2);
          pos1 = pos2 + 1;
          // Serial.println(wert);
          Wire.write(wert.toInt());
        } // solange daten
        Wire.endTransmission();                           // I2C Stopbedingung
        Antwort += "OK ";
      }//if schreiben
    } // If Adresse eine zahl.
    /*
    Serial.print ("Adresse: ");
     Serial.print (server.argName ( br ) );
     Serial.print (" Wert: ");
    Serial.println ( server.arg ( br ) );
    */
  } // Argumente aufzählung
ueberspringe:
  server.sendHeader("Cache-Control", "no-cache");
  server.send(200, "text/plain", Antwort); // Antwort an Internet Browser senden
}

void Ereignis_GetXML()
{
  String Antwort = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\r\n<I2C>\r\n";
  for ( uint8_t br = 0; br < server.args(); br++ )
  {
    String Adresse = server.argName ( br );
    int Adr = Adresse.toInt();
    if (Adr)
    {
      String Data = server.arg (br);
      if (bitRead(Adr, 0))
      { // Lesen
        int Bytes = Data.toInt();
        Antwort += "<A" + Adresse + ">\r\n";
        Adr = Adr >> 1;
        Wire.requestFrom(Adr, Bytes);    //
        while (Wire.available())
        {
          i = Wire.read(); // receive a byte as character
          Antwort += "<Byte>" + String(i) + "</Byte>\r\n";
        }
        Antwort += "</A" + Adresse + ">\r\n";
      } //if lesen
      else
      { // Schreiben

      }//if schreiben
    } // If Adresse eine zahl.
  } // Argumente aufzählung
  Antwort += "</I2C>";
  server.sendHeader("Cache-Control", "no-cache");
  server.send(200, "text/xml", Antwort); // Antwort an Internet Browser senden
}


void Ereignis_Index()       // Wird ausgefuehrt wenn "http://<ip address>/" aufgerufen wurde
{
  server.send(200, "text/plain", indexHtml);        // HTML Webseie befindet sich im "Index.h"
}

void loop()
{
#if defined DNS
  if (AP)dnsServer.processNextRequest();
 #endif
 server.handleClient();                           // Server Ereignisse abarbeiten
  
}




